HDU 1505 City Game (hdu1506 dp二维加强版)

F - City Game

Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u

Submit Status Practice HDU 1505

Appoint description:

Description

Bob is a strategy game programming specialist. In his new city building game the gaming environment is as follows: a city is built up by areas, in which there are streets, trees,factories and buildings. There is still some space in the area that is unoccupied. The strategic task of his game is to win as much rent money from these free spaces. To win rent money you must erect buildings, that can only be rectangular, as long and wide as you can. Bob is trying to find a way to build the biggest possible building in each area. But he comes across some problems ? he is not allowed to destroy already existing buildings, trees, factories and streets in the area he is building in.

Each area has its width and length. The area is divided
into a grid of equal square units.The rent paid for each unit on which
you‘re building stands is 3$.

Your task is to help Bob solve this problem. The whole
city is divided into K areas. Each one of the areas is rectangular and
has a different grid size with its own length M and width N.The existing
occupied units are marked with the symbol R. The unoccupied units are
marked with the symbol F.

Input

The first line of the input contains an integer K ? determining the
number of datasets. Next lines contain the area descriptions. One
description is defined in the following way: The first line contains two
integers-area length M<=1000 and width N<=1000, separated by a
blank space. The next M lines contain N symbols that mark the reserved
or free grid units,separated by a blank space. The symbols used are:

R ? reserved unit

F ? free unit

In the end of each area description there is a separating line.

Output

For each data set in the input print on a separate line, on the
standard output, the integer that represents the profit obtained by
erecting the largest building in the area encoded by the data set.

Sample Input

2
5 6
R F F F F F
F F F F F F
R R R F F F
F F F F F F
F F F F F F

5 5
R R R R R
R R R R R
R R R R R
R R R R R
R R R R R 

Sample Output

45 0

#include<stdio.h>
#include<string.h>
#include<iostream>
#include<algorithm>
using namespace std;
int d[1010][1010];
int l[1010];
int r[1010];
int main()
{
    int n;
    cin>>n;
    while(n--)
    {
        int a,b;
        cin>>a>>b;
      //  memset(d,0,sizeof(d));
        for(int i=0; i<a; i++)
        {
            for(int j=0; j<b; j++)
            {
                char c[2];
                cin>>c;
                if(c[0]==‘F‘)
                    d[i][j]=1;
                else
                    d[i][j]=0;
            }
        }
        /*
0 1 1 1 1 1                         0 1 1 1 1 1
1 1 1 1 1 1  (F=1,R=0,方便求和)    1 2 2 2 2 2
0 0 0 1 1 1  转化完就是右边矩阵     0 0 0 3 3 3
1 1 1 1 1 1                         1 1 1 4 4 4
1 1 1 1 1 1                         2 2 2 5 5 5
        */
        for(int i=1; i<a; i++)
        {
            for(int j=0; j<b; j++)
            {
                if(d[i][j]!=0)
                    d[i][j]=d[i-1][j]+1;
            }
        }
     /*   printf("--------------->\n");
        for(int i=0; i<a; i++){
            for(int j=0; j<b; j++)
                printf("%d ",d[i][j]);
            printf("\n");
        }

           printf("----------------->\n");*/
        int max=0;
        for(int i=0; i<a; i++){
            for(int j=0; j<b; j++){
                l[j]=j;
                while(l[j]>0&&d[i][l[j]-1]>=d[i][j])
                       l[j]=l[l[j]-1];
            }
            for(int j=b-1; j>-1; j--){
                r[j]=j;
                while(r[j]<b-1&&d[i][r[j]+1]>=d[i][j])
                    r[j]=r[r[j]+1];
            }
            for(int j=0; j<b; j++)
                if(max<((r[j]-l[j]+1)*d[i][j]))
                    max=((r[j]-l[j]+1)*d[i][j]);
        }
        cout<<max*3<<endl;
    }
    return 0;
}
时间: 2024-08-23 23:29:46

HDU 1505 City Game (hdu1506 dp二维加强版)的相关文章

hdu 1505 City Game(hdu1506的二维推广)

1.输入的时候数据的时候要注意 2.1506的二维推广 代码: #include<cstdio> #include<cstring> #include<algorithm> using namespace std; const int INF=1<<30; int a[1005][1005]; int L[1005]; int R[1005]; int main() { int t; int m,n; int ans; char s[10]; scanf(&

HDU 1505 City Game【DP】

题意:是二维的1506,即在1506的基础上,再加一个for循环,即从第一行到最后一行再扫一遍--- 自己写的时候,输入的方法不对---发现输不出结果,后来看了别人的[email protected][email protected]发现是将字母和空格当成一个字符串来输入的. #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> using namespace st

hdu 1505 City Game (hdu1506加强版)

# include <stdio.h> # include <algorithm> # include <string.h> # include <iostream> using namespace std; char a[1010][1010]; int dd[1010][1010];///宽度 int r[1010],l[1010]; int main() { int t,i,j,n,m,max1; while(~scanf("%d"

HDU - 1505 City Game(dp)

题意:求由R和F组成的矩阵中,最大的由F组成的矩阵面积. 分析: 1.hdu1506http://www.cnblogs.com/tyty-Somnuspoppy/p/7341431.html与此题相似. 2.将矩阵的每行看成1506中的坐标轴分别处理. 3.算出以该行为坐标轴,坐标轴上,每个由F组成的矩形的高度,与1506的区别是,1506中每个矩形高度已知. 4.按照1506的方法分别算出每个矩形最左边和最右边连续比其高的矩形的下标,通过(r[i][j] - l[i][j] + 1) * h

hdu 1823 Luck and Love ,二维线段树

Luck and Love Time Limit: 10000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 5282    Accepted Submission(s): 1324 Input 本题有多个测试数据,第一个数字M,表示接下来有连续的M个操作,当M=0时处理中止. 接下来是一个操作符C. 当操作符为'I'时,表示有一个MM报名,后面接着一个整数,H表示身

HDU 5119 Happy Matt Friends(简单二维dp)

题意不再说了,就是一个二维的dp,维持取最大值是多少. Happy Matt Friends Time Limit: 6000/6000 MS (Java/Others)    Memory Limit: 510000/510000 K (Java/Others) Total Submission(s): 608    Accepted Submission(s): 229 Problem Description Matt has N friends. They are playing a ga

HDU 2888:Check Corners(二维RMQ)

http://acm.hdu.edu.cn/showproblem.php?pid=2888 题意:给出一个n*m的矩阵,还有q个询问,对于每个询问有一对(x1,y1)和(x2,y2),求这个子矩阵中的最大值,和判断四个角有没有等于这个最大值的. 思路:二维RMQ模板题.注意内存卡的挺紧的. 1 #include <cstdio> 2 #include <cstring> 3 #include <algorithm> 4 #include <cmath> 5

hdu6078 Wavel Sequence dp+二维树状数组

//#pragma comment(linker, "/STACK:102400000,102400000") /** 题目:hdu6078 Wavel Sequence 链接:http://acm.hdu.edu.cn/showproblem.php?pid=6078 题意:给定a序列和b序列.从a中取一个子序列x(数的位置顺序保持不变),子序列每个数满足a1<a2>a3<a4>a5<a6... 波浪形 从b中取相同长度的子序列y,也满足波浪形. 如果x

HDU 1024 Max Sum Plus Plus(二维数组转化为一维数组)

Problem Description: Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem. Given a consecutive number seq